// flipper code

var gDoneButton;
var gInfoButton;
 
function setup()
{
    gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);
    gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showPrefs);
}

function showPrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToBack");
 
    front.style.display="none";
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hidePrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    back.style.display="none";
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}



// this widget in particular

function Randomize() 
{
	var now = new Date();
	n = now.getSeconds() / 6;
	while (n-- > 0) {
		Math.random();
	}
}

// Exclude look-alikes (0 1 l I O)
var numberChars = "23456789";
var lowerChars = "abcdefghijkmnopqrstuvwxyz";
var upperChars = "ABCDEFGHJKLMNPQRSTUVWXYZ";
var otherChars = "-=#$.:?+![]&@*_";

// return random integer x such that lo <= x < hi
function randomInt(lo, hi) 
{
	t = Math.random();
	return Math.floor( lo*t + (hi)*(1-t));
}

function randomUpper() 
{
	t = randomInt(0, upperChars.length);
	return upperChars.charAt(t);
}

function randomLower() 
{
	t = randomInt(0, lowerChars.length);
	return lowerChars.charAt(t);
}

function randomDigit() 
{
	t = randomInt(0, numberChars.length);
	return numberChars.charAt(t);
}

function randomPunct() 
{
	t = randomInt(0, otherChars.length);
	return otherChars.charAt(t);
}


// first generator

function GeneratePassword() 
{
	Randomize();
    var ndx = document.PassGenForm.numChars.selectedIndex;
    var length = document.PassGenForm.numChars.options[ndx].value;
    if (length == 0) {
        length = randomInt(6, 13);
    }

    var allowPunctuation = document.PassGenForm.doPun.checked;

	document.PassGenForm.password.value = passGen2(length, allowPunctuation);

    return true;
}

function passGen1(len, allowPun) 
{
	sPass = randomUpper();
	for (i=1; i<len; i++) {
		t = Math.random();
		if (t<.1) {
			ch = allowPun ? randomPunct() : randomLetter(1);
		}
		else if (t<.3) {
			ch = randomUpper();
		}
		else if (t<.8) {
			ch = randomLower();
		} else {
			ch = randomDigit();
		}
		sPass = sPass + ch;
	}
	return sPass;
}

function passGen2(len, allowPun)
{
	// build a pattern string
	pattern = "Cccddc";
	for (i=6; i<len; i++) {
		t = Math.random();
		if (t < .2) {
			pattern += "C";
		}
		else if (t < .8) {
			pattern += "c";
		} else {
			pattern += "d";
		}
	}
	
	if (allowPun) {
		t = randomInt(1, len);
		pattern = pattern.slice(0,t) + "p" + pattern.slice(t+1);
		t = randomInt(1, len);
		pattern = pattern.slice(0,t) + "p" + pattern.slice(t+1);
	}
	
	return passGenFromPattern(pattern);
}

function passGenFromPattern(pattern)
{
	sPass = "";
	for (i=0; i<pattern.length; i++) {
		f = pattern.charAt(i);
		switch (f) {
			case 'C': c = randomUpper(); break;
			case 'c': c = randomLower(); break;
			case 'd': c = randomDigit(); break;
			case 'p': c = randomPunct(); break;
		}
		sPass += c;
	}
	return sPass;
}


// second generator

function getCharSet(number, lower, upper, other, extra) 
{
	var charSet = extra;
	if (number) charSet += numberChars;
	if (lower) charSet += lowerChars;
	if (upper) charSet += upperChars;
	if (other) charSet += otherChars;
	return charSet;
}

function getChar(charSet) 
{
	return charSet.charAt(Math.floor(Math.random()*charSet.length));
}

function getPassword(length, extraChars, firstNumber, firstLower, firstUpper, firstOther,
latterNumber, latterLower, latterUpper, latterOther) 
{
	Randomize();
	if (length < 3) length = 3;
	if (length > 20) length = 20;

	var charSet = getCharSet(firstNumber, firstLower, firstUpper, firstOther, extraChars);
	var rc = getChar(charSet);
	
	charSet = getCharSet(latterNumber, latterLower, latterUpper, latterOther, extraChars);
	for (var i = 1; i < length; ++i) {
		rc = rc + getChar(charSet);
	}
	return rc;
}


